﻿Public Class Form1
    ' List the even numbers between 0 and 100.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim x = 1.5

        ' 1. Create the data source.
        Dim numbers(0 To 100) As Integer
        For i As Integer = 0 To 100
            numbers(i) = i
        Next i

        ' 2. Build a query to select data from the data source.
        Dim evenQuery =
            From num As Integer In numbers
            Where IsPrime(num)
            Select num

        ' 3. Execute the query and process the result.
        For Each num As Integer In evenQuery
            lstPrimeNumbers.Items.Add(num)
        Next num
    End Sub

    ' Return True if the number is prime.
    Private Function IsPrime(ByVal num As Integer) As Boolean
        ' 1 is not prime.
        If (num = 1) Then Return False

        ' 2 is prime.
        If (num = 2) Then Return True

        ' See if num is divisible by 2.
        If (num Mod 2 = 0) Then Return False

        ' See if num is divisible by odd numbers.
        Dim max As Integer = CInt(Math.Sqrt(num))
        For i As Integer = 3 To max Step 2
            If (num Mod i = 0) Then Return False
        Next i

        ' If we got this far, num is prime.
        Return True
    End Function
End Class
