﻿Imports System.IO

Public Class Form1
    ' Start at the startup directory.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        txtDirectory.Text = Application.StartupPath
    End Sub

    ' Search for files matching the pattern
    ' and containing the target string.
    Private Sub btnSearch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSearch.Click
        lstFiles.DataSource = Nothing
        lstFiles.Items.Clear()

        ' Get the file pattern and target string.
        Dim pattern As String = cboPattern.Text
        Dim target As String = txtTarget.Text.ToLower()

        ' Search for files.
        Dim dirinfo As New DirectoryInfo(txtDirectory.Text)
        Dim fileQuery =
            From info As FileInfo
            In dirinfo.GetFiles(pattern, SearchOption.AllDirectories)
            Where File.ReadAllText(info.FullName).
                ToLower().Contains(target)
            Select info.FullName

        ' Display the result.
        lstFiles.DataSource = fileQuery.ToArray()
    End Sub
End Class
